﻿import flash.geom.ColorTransform;
import flash.geom.Transform;

stop();
_global.ROOT=this;

FPS=12;
STAGE_W=750;
STAGE_H=750;

FX_VOLUME=100;

INIT_IDEAS=8;
PEOPLE=10;
INIT_CONSUMERS=5;
MAX_IDEAS=PEOPLE*2;

VECTORIALIST_RADIUS=350;
VECTORIALIST_CENTER=35;
VECTORIALIST_RANGE=300;
VECTORIALIST_CHARGE=-1;
VECTORIALIST_COLLECTING_TIME=70; //frames
VECTORIALIST_MAX_STORAGE=10;
VECTORIALIST_MAX_SPEED=10; //degrees per frame
VECTORIALIST_MIN_SPEED=5; //degrees per frame
//MIN_INSPECTION_TIMER=10;
MAX_INSPECTION_TIMER=100;

OBSTRUCTION_ANGLE=10;	//ideally avoids to stop in front of a free person
FIRST_INSPECTION_TIMER=30;

MARGIN_REPULSION_DIVIDER=10;
MARGIN_RADIUS=300;

PERSON_RADIUS=260;
PERSON_DISTANCE=10; //min distance between people in degree
PERSON_HEAD_Y=40;
PERSON_RANGE=40;
PERSON_CHARGE=-1;
PERSON_VELOCITY=-4;
IDEAS_SATISFACTION=20;
MIN_INIT_SATISFACTION=20; //30;
IMPATIENCE=.12; 					// % of satisfaction reduced every frame
WAIT_ANIMATIONS_FREQUENCY=100;
SATISFACTION_TRESHOLD=50; 		//switch threshold

NEW_IDEA_SPEED=50;
NEW_IDEA_TIME=12*FPS; //seconds

FRICTION=0.7;
ROT_FRICTION=0.9;
MAX_ROT=10;
MAX_VELOCITY=10;

CAPTURE_DISTANCE=10;

MAGIC_RANGE=80;
MAGIC_CHARGE=3;
MAGIC_VECTORIALIST_REPULSION=100;

FADE_SPEED = 4

soundsOn=true;
this.createEmptyMovieClip("soundBox", -999);

//create a list of random numbers from 1 to 6 to avoid quote repetition at the end
QUOTES=6;
randomIndex=0;
randomArray = new Array();
for(i=0; i<QUOTES; i++)
	randomArray.push({frame:i+1, shuffler:random(100)});
	
randomArray.sortOn("shuffler");


function initGame() 
{
atomicBomb();
stopAllSounds();
Mouse.hide();
fadeIn();

//create the universe
universe = ROOT.attachMovie("universe", "universe", 10, {_x:STAGE_W/2, _y:STAGE_H/2});
universe.exitBtn.onRelease = function() { initMenu(); }

underLayer = ROOT.createEmptyMovieClip("underLayer", 20);
field = ROOT.createEmptyMovieClip("fieldLayer", 30);
overLayer = ROOT.createEmptyMovieClip("overLayer", 40);

//create the magic (copyleft cursor)
magic=overLayer.attachMovie("magic", "magic", 10);
magic.influencer=true;
magic.influenced=false;
magic.vx=0;
magic.vy=0;
magic.range=MAGIC_RANGE;
magic.charge=MAGIC_CHARGE;
magic.velocity=10;

magic.onEnterFrame = function() {

	//repulsion with vectorialist
	dx = vectorialist._x - this._x;
	dy = vectorialist._y - this._y;
    distance = Math.sqrt(dx*dx + dy*dy);
    vx=0;
	vy=0;
	//am I too close to the vect?
	if (distance < MAGIC_VECTORIALIST_REPULSION)
		{
		direction = Math.atan2(dy,dx);
   		attenuator = MAGIC_VECTORIALIST_REPULSION-((1-distance/MAGIC_VECTORIALIST_REPULSION)*100);
		}
	else
		attenuator=100;
		
	//attenuate magic power
	this._xscale=this._yscale=attenuator;
	this.range=MAGIC_RANGE/100*attenuator;
	this.charge=MAGIC_CHARGE/100*attenuator;
	
	//did the mouse move?
	if((this._x !=_xmouse || this._y!=_ymouse) )
		{
		//create magnetic children
		//they add persistence to the magic field (arguably useless)
		d=field.getNextHighestDepth();
		child=field.attachMovie("empty", "child_"+d, d, {_x:_xmouse,_y:_ymouse});
		
		child.influencer=true;
		child.influenced=false;
		child.vx=0;
		child.vy=0;
		child.range=30/100*attenuator;
		child.charge=3/100*attenuator;
		child.velocity=10;

		child.onEnterFrame = function() { 
			this.range-=1;
			if(this.range<10)
				removeMovieClip(this);
			}
		}
	
	//update my position
	this._x=_xmouse;
	this._y=_ymouse;
	}
//end magic
	
//create ideas
freeIdeas=0;
for(i=0; i<INIT_IDEAS; i++)
	{
	ang=random(360)+1;
	radius=random(100);
	xPos = STAGE_W/2 + radius * Math.cos(ang);
    yPos = STAGE_H/2 + radius * Math.sin(ang);
	createIdea(xPos, yPos);
	}


//create vectorialist
d=field.getNextHighestDepth();
vectorialist = overLayer.createEmptyMovieClip("vectorialist", d);
vectorialist.attachMovie("copyright", "copyright", 30, {_x:-35});

vectorialist.type="vectorialist";
vectorialist.animate("normal");

vectorialist.ang=random(360)+1;
vectorialist.influencer=true;
vectorialist.influenced=false;
vectorialist.capturer=true;
vectorialist.vx=0;
vectorialist.vy=0;
vectorialist.range=VECTORIALIST_RANGE;
vectorialist.charge=VECTORIALIST_CHARGE;
vectorialist.speed=5;
vectorialist.velocity=-5;
vectorialist.directive="move";
vectorialist.destination=random(360)+1;
vectorialist.stored = 0;

vectorialist.timer=0; //collection timer
vectorialist.inspectionTimer= MAX_INSPECTION_TIMER; //time to the first inspection

vectorialist.onEnterFrame = vectorialistRoutine


//create people
peopleInUniverse = new Array();
consumers=0;

for(i=0; i<PEOPLE; i++)
	{
	d=field.getNextHighestDepth();
	person = field.createEmptyMovieClip("person_"+d, d);
	
	person.type = "person";

	//position them avoiding overlappings
	positioned=false;
	antiCrash=0;
	while(!positioned && antiCrash<1000)
		{
		person.ang=random(360)+1;
		positioned=true;
		antiCrash++;
		//test the position
		for(p=0; p<peopleInUniverse.length; p++)
			if(Math.abs(person.ang-peopleInUniverse[p].ang)<PERSON_DISTANCE)
				positioned=false;
		}
	
	//put the guy on the circle
	rad = Math.PI*person.ang/180;
	person._rotation=-90+person.ang;

	xPos = STAGE_W/2 + (PERSON_RADIUS-PERSON_HEAD_Y) * Math.cos(rad);
   	yPos = STAGE_H/2 + (PERSON_RADIUS-PERSON_HEAD_Y) * Math.sin(rad);
	
	person._x = xPos;
	person._y = yPos;
	
	peopleInUniverse.push(person);
	
	person.range=PERSON_RANGE;
	person.charge=PERSON_CHARGE;
	person.velocity=PERSON_VELOCITY;
	
	//create consumer
	if(consumers<INIT_CONSUMERS)
		{
		consumers++;
		person.influencer=false;
		person.influenced=false;
		person.capturer=false;
		person.consumer=true;
		person.satisfaction= -(MIN_INIT_SATISFACTION+random(100-MIN_INIT_SATISFACTION));
		person.animate("consumer");
		}
	//create free person
	else
		{
		person.influencer=true;
		person.influenced=false;
		person.capturer=true;
		person.consumer=false;
		person.satisfaction=MIN_INIT_SATISFACTION+random(SATISFACTION_TRESHOLD-MIN_INIT_SATISFACTION);;
		person.thinkingTimer=random(NEW_IDEA_TIME);
		person.animate("free");
		}
	
	person.onEnterFrame = personRoutine
	}
	//end people
}



function createIdea(x, y)
{
freeIdeas++;

d=field.getNextHighestDepth();
idea=field.attachMovie("idea", "idea_"+d, d, {_x:x, _y:y});
idea._rotation=random(360);

idea.influencer=true;
idea.influenced=true;
idea.type="idea";
idea.vx=0;
idea.vy=0;
idea.range=20;
idea.charge=2;
idea.velocity=0;

idea.onEnterFrame = function() {
	
	//how far am I from the center?
	dx =   this._x - STAGE_W/2;
	dy =  this._y - STAGE_H/2;
	this.dist = Math.sqrt(dx*dx + dy*dy);
			
	//find the absolute angle (from the center)
	rad=Math.atan2(dy,dx);
	ang = rad * 180 / (Math.PI);
	if(ang<0) ang = 360 + ang;
	
	this.ang = ang;
	
	//margin repulsion
	if(this.dist>MARGIN_RADIUS)
		{
		repulsion = this.dist-MARGIN_RADIUS;
		this.vx -= (repulsion/MARGIN_REPULSION_DIVIDER * Math.cos(this.ang));
		this.vy -= (repulsion/MARGIN_REPULSION_DIVIDER * Math.sin(this.ang));
		}
	
	//magnetic field
	for(mc in field)
		if(field[mc].influencer && field[mc]!=this)
			magnetism(field[mc], this);
			
	if(vectorialist.influencer)
		magnetism(vectorialist, this);
	
	magnetism(magic, this);
	
	// reduce velocity by friction so I won't move for ever
	this.vx *= FRICTION;
	this.vy *= FRICTION;
	this.rot *= ROT_FRICTION;
	
	this._rotation+=this.rot;
	this._x += this.vx;
	this._y += this.vy;
	}
	
return idea
}


function magnetism(thisOne, theOther)
{
	// dx and dy are the differences in distance of the two objects
	dx = theOther._x - thisOne._x;
	dy = theOther._y - thisOne._y;
   
    // pythagorean theorem used to get actual linear distance
    distance = Math.sqrt(dx*dx + dy*dy);
    
    // if the distance is less than the range specified the clip will need to be repulsed
    if (distance < thisOne.range)
		{
		oldDirection = thisOne.direction;
	
	   	//find the direction
   		thisOne.direction = Math.atan2(dy,dx);
     
    	// a proximity ratio is created to represent how close the
   		// objects are when closer, more speed is applied
    	proximity = 1 - distance/thisOne.range;
       
    	// increase velocity by speed factoring in proximity
		if(thisOne.capturer==undefined)
			thisOne.velocity += thisOne.charge * proximity;
		
		//limit velocity
		if(thisOne.velocity>MAX_VELOCITY)
			thisOne.velocity=MAX_VELOCITY;
		
		//affect speed
		if(thisOne.influenced)
			{
			thisOne.vx -= (thisOne.velocity/2 * Math.cos(thisOne.direction));
			thisOne.vy -= (thisOne.velocity/2 * Math.sin(thisOne.direction));
			}
		
		if(theOther.influenced)
			{
			theOther.vx += thisOne.velocity/2 * Math.cos(thisOne.direction);
			theOther.vy += thisOne.velocity/2 * Math.sin(thisOne.direction);
			}
	
	//quick and dirty spin effect
	spin = (dx>0) ? thisOne.direction - oldDirection : oldDirection - thisOne.direction;
	theOther.rot =  theOther.vx * spin * 10;
	if(theOther.rot>MAX_ROT) 	theOther.rot=MAX_ROT;
	if(theOther.rot<-MAX_ROT) 	theOther.rot=-MAX_ROT;
	
	}
   
  //capture
  if(thisOne.capturer && theOther.influenced && distance<CAPTURE_DISTANCE)
		{
		//captured by vector
		if(thisOne.type=="vectorialist")
			{
			thisOne.animate("wacca", "open");
			thisOne.stored++;
			}
			
		//captured by person
		if(thisOne.type=="person")
			{
			thisOne.satisfaction+=IDEAS_SATISFACTION;
			thisOne.animate("getIdea", "free");
			
			if(thisOne.satisfaction>100) 
				thisOne.satisfaction=100;
			
			//is the little person already thinking?
			if(thisOne.thinkingTimer<=0)
				thisOne.thinkingTimer=NEW_IDEA_TIME;
			}
		
		if(theOther.type=="idea")
			freeIdeas--;
		
		removeMovieClip(theOther);
		}
}


function personRoutine()
{
//am I a consumer?
if(this.consumer)
	{
	//I just wait to be served
	
	//Am I satisfied or kinda satisfied?
	if(this.satisfaction<SATISFACTION_TRESHOLD)
		{
		this.satisfaction+=IMPATIENCE;
		sat=this.satisfaction+50;
		mmt.SaturationManager.setSaturation(this, 0);
		}
	//Am I unsatisfied? Become a prosumer in the common
	else
		{
		this.animate("toFree", "free");
			
		this.capturer=true;
		this.consumer=false;
		this.influencer=true;
		this.satisfaction=SATISFACTION_TRESHOLD;
		consumers--;
		//end game
		if(consumers<=0)
			endSequence();			
		}
	
	//wait animation
	if(this.currentAnimation=="consumer" && random(WAIT_ANIMATIONS_FREQUENCY)==0)
		{
		if(this.satisfaction>0)
			this.animate("wait3b", "consumer");
		else if(this.satisfaction>-10)
			this.animate("wait2b", "consumer");
		else if(this.satisfaction>-20)
			this.animate("wait1b", "consumer");
		}
		
	}
//I'm not a consumer
else if(!this.consumer)
	{
	//Had I been thinking enough?
	if(this.thinkingTimer<=0)
		{
		//shoot a new idea in the common
		rad = Math.PI*this.ang/180;
		dx=-(NEW_IDEA_SPEED * Math.cos(rad));
		dy=-(NEW_IDEA_SPEED * Math.sin(rad));
		
		//if the number of idea is OK
		if(freeIdeas<MAX_IDEAS)
			{
			if(this.currentAnimation!="toConsumer")
				this.animate("newIdea", "free");
		
			newIdea = createIdea(this._x+dx, this._y+dy);
			newIdea.vx = dx;
			newIdea.vy = dy;
			}
		//think again
		this.thinkingTimer=NEW_IDEA_TIME;//(110-this.satisfaction)*3;
		}
		//No? Think some more...
		else
			this.thinkingTimer--;
		
	
	//am I satisfied or kinda satisfied
	if(this.satisfaction>-SATISFACTION_TRESHOLD)
		{
		this.satisfaction-=IMPATIENCE;
		sat=100/(100+SATISFACTION_TRESHOLD)*(this.satisfaction+SATISFACTION_TRESHOLD);
		mmt.SaturationManager.setSaturation(this, sat);
		}
	//am I unsatisfied? I become a consumer
	else //if(vectorialist.stored>0)// && peopleInUniverse.length-consumers > MIN_FREE_PEOPLE)
		{
		this.animate("toConsumer", "consumer");
		
		this.capturer=false;
		this.consumer=true;
		this.influencer=false;
		this.satisfaction=-SATISFACTION_TRESHOLD;
		consumers++;
		}
		
	//wait animation
	if(this.currentAnimation=="free" && random(WAIT_ANIMATIONS_FREQUENCY)==0)
		{
		if(this.satisfaction<0)
			this.animate("wait3", "free");
		else if(this.satisfaction<10)
			this.animate("wait2", "free");
		else if(this.satisfaction<20)
			this.animate("wait1", "free");
		}
	}

}
	


function vectorialistRoutine() 
{
//by default I don't influence
this.influencer=false;

//do I have a target? its angle is the destination
if(this.target!=undefined)
	this.destination = this.target.ang;

//my energy depends on the number of consumer
//this.energy=Math.round(consumers/peopleInUniverse.length*100)+1;

//do I have a destination and am I ready to move?
if(this.destination!=undefined && this.currentAnimation!="sellIdea")
	{
	//move
	vec =this.ang;
	
	//find the delta angle
	da=this.destination - vec;
	
	if(da>180) 	da= -(vec+360-this.destination);
	if(da<-180) da= this.destination+360-vec;
	
	step=da/4;
	
	if(Math.abs(step)<VECTORIALIST_MIN_SPEED)	step = (step>0) ? VECTORIALIST_MIN_SPEED : -VECTORIALIST_MIN_SPEED;
	if(Math.abs(step)>VECTORIALIST_MAX_SPEED)	step = (step>0) ? VECTORIALIST_MAX_SPEED : -VECTORIALIST_MAX_SPEED;
	
	//am I arrived?
	if(Math.abs(da)<VECTORIALIST_MIN_SPEED)
		{
		this.ang=this.destination;
		//what was my mission?
		
		//delivering? 
		if(this.directive=="deliver")
		  //is my target still a consumer?
		  if(this.target.consumer)
			{
			sellIdea(this.target)
			//reset target and destination
			this.target=undefined;
			this.destination=undefined;
			}
		else
			{
			//find another target
			this.target=undefined;
			this.destination=undefined;
			}
			
		//collecting? initialize collection
		if(this.directive=="collect")
			{
			//init collection
			this.timer=VECTORIALIST_COLLECTING_TIME;
	 		this.animate("open");
			//reset target and destination
			this.target=undefined;
			this.destination=undefined;
			}
		}
	else
		//not arrived? move
		this.ang+=step;
	
	//rotate
	if(this.ang<0)		this.ang=360+this.ang;
	if(this.ang>360)	this.ang=this.ang-360;
	
	rad = Math.PI*this.ang/180;
	
	xPos = STAGE_W/2 + (VECTORIALIST_RADIUS-VECTORIALIST_CENTER) * Math.cos(rad);
	yPos = STAGE_H/2 + (VECTORIALIST_RADIUS-VECTORIALIST_CENTER) * Math.sin(rad);
	
	this._rotation=-180+this.ang;
	this._x = xPos;
	this._y = yPos;	
	}
//rotate the C
this.copyright._rotation=180-this.ang;


//operative stuff
switch(this.directive)
	{
	//I am moving without a destination
	case "move":
	
	trace("moving... countdown to the next inspection: "+this.inspectionTimer);
	
	this.inspectionTimer--;
	
	//time for inspection?
	if(this.inspectionTimer<=0)
		{
		this.directive="inspect";
		this.destination=undefined;
		this.target=undefined;
		}
	break;
	
	case "inspect":
	//trace("inspecting...");
	this.influencer=false;
	
	if(this.destination==undefined)
	{
	inspectArray = new Array();
	
	//gather all the information about free ideas
	for(i in field)
		//is it good to eat? is it within the range?
		if(field[i].type=="idea" && VECTORIALIST_RADIUS-field[i].dist<this.range)
			inspectArray.push({distance:field[i].dist, angle:field[i].ang});
		
	//sort by distance
	inspectArray.sortOn("distance", Array.NUMERIC | Array.DESCENDING);
	
	found=false;
	
	//check for conflicting people
	for(i=0; i<inspectArray.length && !found; i++)
		{
		obstructed=false;
		//check if the angle is close to a person's one
		for(p in field)
			{
			if(field[p].consumer==false)
				{
				da=Math.abs(field[p].ang-inspectArray[i].angle);
				if(da<OBSTRUCTION_ANGLE) obstructed=true;
				}
			}
		if(!obstructed) found=true;
		}
	
	index = (found) ? i-1 : 0;
	
	//something detected
	if(inspectArray.length>0)
		{
		this.destination=inspectArray[index].angle;
		this.directive="collect";
		//trace("ideas found collecting at"+this.destination);
		}
	else
		{
		this.animate("close");
		this.directive="move";
		//this.inspectionTimer=this.energy+MIN_INSPECTION_TIMER;
		if(consumers>2)
			this.inspectionTimer=MAX_INSPECTION_TIMER -((freeIdeas/MAX_IDEAS) * MAX_INSPECTION_TIMER);
		else
			this.inspectionTimer=MAX_INSPECTION_TIMER/consumers;
			
		//trace("set timer "+this.inspectionTimer);
			
		this.destination = random(360)+1;
		//trace("no ideas found going random "+this.destination);
		}
	}
	break;
	
	case "collect":
	//trace("moving to collect");
	
	if(this.destination==undefined)
	{
	//trace("collecting... countdown: "+this.timer);
	
	if(underLayer.beam==undefined)
		{
		underLayer.attachMovie("beam", "beam", 10, {_x:this._x, _y:this._y});
		underLayer.beam._rotation = this.ang+180;
		}
	
	this.timer--;
	this.influencer=true;
	detected=true;
	
	//sometimes I check if there are ideas in my range
	if(this.timer%4==0)
	{
	detected=false;
	
	for(i in field)
		//is it good to eat?
		if(field[i].influenced)
			{
			//how far is it from the center?
			dx =   field[i]._x - this._x;
			dy =  field[i]._y - this._y;
			distance = Math.sqrt(dx*dx + dy*dy);
			
			if(distance<this.range && !detected)
				detected=true;
			}
	}
	

	//time is over or there's no reason to use the tractor beam or I'm full
	if(this.timer<=0 || !detected || this.stored>=VECTORIALIST_MAX_STORAGE)
		{
		//something to deliver to someone?
		if(consumers>0 && this.stored>0)
			{
			this.directive="deliver";
			
			if(this.currentAnimation=="wacca")
			   this.animate("wacca", "normal");
			else
				this.animate("close", "normal");
			}
		else 
			{
			this.directive="move";
			this.animate("close", "normal");
			//this.inspectionTimer=this.energy+MIN_INSPECTION_TIMER;
			if(consumers>2)
				this.inspectionTimer=MAX_INSPECTION_TIMER -((freeIdeas/MAX_IDEAS) * MAX_INSPECTION_TIMER);
			else
				this.inspectionTimer=MAX_INSPECTION_TIMER/consumers;
			
			//trace("set timer "+this.inspectionTimer);
			this.destination = random(360)+1;
			}
		removeMovieClip(underLayer.beam);
		}
		
	}
	break;
	
	case "deliver":
	//trace("delivering....");
	
	//if no target find one
	if(this.target==undefined && this.stored>0)
		{
		//trace(this.stored+" ideas available. looking for target");
		
		consumersArray = new Array();
		
		//find unsatisfied people
		for(i=0; i<peopleInUniverse.length; i++)
			if(peopleInUniverse[i].consumer)
				//sort-friendly array
				consumersArray.push( {reference:peopleInUniverse[i], satisfaction:peopleInUniverse[i].satisfaction});
		
		//trace(consumersArray.length+ " consumers found");
		
		//equal distribution rank the consumers (people in the market) according to their satisfaction
		//consumersArray.sortOn("satisfaction", Array.NUMERIC | Array.DESCENDING);
		//deliver to the most unsatisfied
		//this.target = consumersArray[0].reference;
		
		//unequal distribution
		this.target = consumersArray[random(consumersArray.length)].reference;
		
		//trace("target found: "+this.target+ " satisfaction level : "+consumersArray[1].satisfaction);
		}
	else if(this.stored==0)
		{
		//trace("delivery complete");
		this.directive = "move";
		//this.inspectionTimer=this.energy+MIN_INSPECTION_TIMER;
		if(consumers>2)
			this.inspectionTimer=MAX_INSPECTION_TIMER -((freeIdeas/MAX_IDEAS) * MAX_INSPECTION_TIMER);
		else
			this.inspectionTimer=MAX_INSPECTION_TIMER/consumers;
			
		this.destination = random(360)+1;
		trace("set timer "+this.inspectionTimer);
			
		}
	
	break;
	
	}

}

function sellIdea(customer)
{
vectorialist.stored--;
//trace("selling idea to "+customer._name);
customer.satisfaction-=IDEAS_SATISFACTION;
vectorialist.animate("sellIdea", "normal");
vectorialist.copyright.gotoAndPlay("money");

if(this.currentAnimation!="toFree")
	customer.animate("buyIdea", "consumer");
}


MovieClip.prototype.animate = function(anim, nextAnim)
{
if(this.currentAnimation!=anim)
	{
	this.attachMovie(this.type+"_"+anim, "animation", 10);
	this.currentAnimation=anim;
	}

if(nextAnim!=undefined)
	{
	this.nextAnimation=nextAnim;

	this.animation.onEnterFrame = function() {
			if(this._currentframe == this._totalframes)
				this._parent.animate(this._parent.nextAnimation);		
			}
	}//
}

function playSound(sound_id, vol)
{
	if(soundsOn)
		{
		id=soundBox.getNextHighestDepth()
		obj=soundBox.createEmptyMovieClip( "sound"+id,  id);
		obj.mc=this;
		obj.sound = new Sound(obj);
		obj.sound.attachSound(sound_id);
		
		if(vol!=undefined)
			obj.vol=FX_VOLUME/100*vol;
		else
			obj.vol=FX_VOLUME;
		
		obj.onEnterFrame = function() {
		
		//remove
		if(this.sound.position>=this.sound.duration)
			{
			removeMovieClip(this);
			}
		else
			{	
			if(this.sound.position==0)
				{
				this.sound.setVolume(this.vol);
				this.sound.start();
				}
			}
		}
	}
}


function endSequence()
{
for(i in field)
	{
	if(field[i].type=="person")
		{
		field[i].influencer=false;
		field[i].capturer=false;
		//bug patch
		sat=100/(100+SATISFACTION_TRESHOLD)*(field[i].satisfaction+SATISFACTION_TRESHOLD);
		mmt.SaturationManager.setSaturation(field[i], sat);
		delete field[i].onEnterFrame
		}
	}
	
removeMovieClip(underLayer.beam);
vectorialist.animate("explode");
vectorialist.influencer = vectorialist.capturer = false;

vectorialist.timer=0;
vectorialist.onEnterFrame = function() {
	this.timer++;
	
	if(this.timer<10)
		{
		this.copyright._xscale+=this.timer;
		this.copyright._yscale+=this.timer;	
		}
	else if(this.timer==10)
		{
		playSound("explosion",70);
		
		for(i=0; i<10; i++)
			{
			flare=this.attachMovie("explosionFlare", "e_"+i, i, {_x:this.copyright._x, _y:this.copyright._y});
			flare._xscale = flare._yscale = random(100)+50;
			flare.ang = random(360);
				/////////////
				flare.onEnterFrame = function() { 
				this._x += this._xscale/10 * Math.cos(this.ang);
				this._y += this._xscale/10 * Math.sin(this.ang);
				this._xscale-=5;
				this._yscale-=5;
				if(this._xscale<10)
					removeMovieClip(this);
				}
				///////
			}		
		removeMovieClip(this.copyright);
		}
		else if(this.timer==25)
			ROOT.universe.gotoAndPlay("contract");
		else if(this.timer==35)
			fadeOut();
		else if(this.timer>40)
			{
			if(ROOT.quotes==undefined)
				{
				qt=ROOT.attachMovie("quotes", "quotes", ROOT.getNextHighestDepth(), {_x:STAGE_W/2, _y:STAGE_H/2});
				qt.gotoAndStop(randomArray[randomIndex].frame);
				randomIndex++;
				
				if(randomIndex>QUOTES)
					randomIndex=1;
					
				qt._alpha=0;
				
				screenClick = ROOT.attachMovie("box", "box", 0, {_width:STAGE_W, _height:STAGE_H, _alpha:0});
				screenClick.onRelease = function()  { 
				initMenu(); }

				}
			else
				qt._alpha+=10;
			}
		
	}
}


//tutorial

function initTutorial()
{
Mouse.show();
atomicBomb();
screenClick = ROOT.attachMovie("box", "box", 0, {_width:STAGE_W, _height:STAGE_H, _alpha:0});
tutorial=ROOT.attachMovie("tutorial", "tutorial", 10);
tutorial.gotoAndStop(1);

playSound("microclick", 100);

slide=1;
tutorial.forwardBtn.onRelease = screenClick.onRelease = function() {
playSound("microclick", 100);
slide++;
tutorial.gotoAndStop("slide"+slide);


if(slide>7)
	{
	removeMovieClip(tutorial);
	Mouse.removeListener(mouseListener);
	initGame();
	
	}
};


tutorial.backBtn.onRelease = function() {
playSound("microclick", 100);
	if(slide>1)
		{
		slide--;
		tutorial.gotoAndStop("slide"+slide);
		}
	}

tutorial.skipBtn.onRelease = function() {
	playSound("microclick", 100);
	initGame();
	}

}



function initMenu()
{
Mouse.show();
atomicBomb();
fadeIn();
var music:Sound = new Sound();
music.attachSound("theme");
music.start(0, 100);

screenClick = ROOT.attachMovie("box", "box", 0, {_width:STAGE_W, _height:STAGE_H, _alpha:0});
mainScreen=ROOT.attachMovie("mainScreen", "mainScreen", 10);

mainScreen.logoButton.onRelease = function() { getURL("http://www.molleindustria.org/", "_blank"); }

mainScreen.speaker.gotoAndStop((soundsOn)? "on" : "off");

mainScreen.soundButton.onRelease = function() { 
	soundsOn=!soundsOn;
	mainScreen.speaker.gotoAndStop((soundsOn)? "on" : "off");
	music.setVolume( (soundsOn)? 100 : 0);
	}
	
screenClick.onRelease = function() {
	initTutorial();	
	}
}

function atomicBomb()
{
	
for(o in ROOT)
	if(ROOT[o]!=fader)
		removeMovieClip(ROOT[o])
}

function fadeIn()
{
fader=ROOT.attachMovie("box", "fader", 10000, {_width:Stage.width, _height:Stage.height});
fader._alpha = 100;
fader.to = 0;

fader.onEnterFrame = function() { 
	this._alpha -= (this._alpha - this.to)/FADE_SPEED;
	if(this._alpha<=0) removeMovieClip(this);
	}
}

function fadeOut()
{
fader=ROOT.attachMovie("box", "fader", 10000, {_width:Stage.width, _height:Stage.height, _alpha:0});
fader.alpha = 0;
fader.to = 100;
fader.comm=comm;

fader.onEnterFrame = function() { 
	this.alpha += ( this.to - this.alpha)/FADE_SPEED;
	this._alpha = this.alpha;
	}
}


function credits()
{
fadeIn()
credits = ROOT.attachMovie("credits", "credits", 0, {_x:Stage.width/2, _y:Stage.height/2});
credits.secs=0;

credits.interval= function()
	{
	this.secs++;
	
	if(this.secs>=4)
		{
		clearInterval(this.id);
		initMenu();
		}
	}
credits.id=setInterval(credits, "interval", 1000);

}


credits();